__version__ = 1, 2, 0
__author__ = '竹永康'
__author_email__ = 'zhuyk4@lenovo.com'

import sys
import asyncio

from multiprocessing.pool import Pool
from multiprocessing.pool import ThreadPool
from multiprocessing.pool import AsyncResult

from typing import Any
from typing import Union
from typing import Iterator
from typing import Callable

__all__ = (
    'IsddcAsyncTasks',
    'IsddcProcessPool',
    'IsddcThreadPool'
)


class IsddcAsyncTasks:

    def __new__(cls, *a, **kw):
        raise NotImplemented

    @classmethod
    def at(
            cls,
            async_func: Callable,
            *a,
            namespace: str = None,
            **kw
    ):
        """Submit an asynchronous function and
        store it in the specified namespace."""

    @classmethod
    def batch_at(
            cls,
            async_func: Callable,
            *params
    ) -> str:
        """Batch submit async task."""

    @classmethod
    def run_until_complete(
            cls,
            namespace: str = None,
            *,
            timeout: int = None,
            return_when: str = asyncio.ALL_COMPLETED
    ) -> tuple:
        """Run all asynchronous function in the
        specified namespace until completed."""

    @classmethod
    def get(
            cls,
            namespace: str = None,
            *,
            timeout: int = None,
            return_when: str = asyncio.ALL_COMPLETED
    ) -> Iterator:
        """Run all asynchronous function in the specified
        namespace until complete, and get all task results."""

    @staticmethod
    def random_namespace() -> str:
        """Return a random uuid4 string."""

    @staticmethod
    def run_async_func(async_func: Callable, *a, **kw) -> Any:
        """Run an asynchronous function and return its result."""


class IsddcProcessPool(Pool):

    def __init__(
            self,
            name: str = None,
            *,
            processes: int = None,
            **kw
    ):
        """
        Create a Process pool.
        @param name:      Pool name.
        @param processes: Process number.
        """

    def at(
            self,
            func: Callable,
            *a,
            namespace: str = None,
            callback: Callable = None,
            error_callback: Callable = None,
            **kw
    ) -> AsyncResult:
        """
        Submit a task to the pool.
        @param func:           A function.
        @param a:              Position parameters of @param(func).
        @param namespace:      Specifies the  name space of @param(func)
                               and creates it if it does not exist.
        @param callback:       Callback function of @param(func).
        @param error_callback: Error callback function of @param(func).
        @param kw:             Keyword parameters of @param(func).
        @return:               Result object.
        """

    def batch_at(
            self,
            func: Callable,
            *params,
            callback: Callable = None,
            error_callback: Callable = None
    ) -> str:
        """Batch submit tasks to the pool, and returns
        the namespace in which these tasks reside."""

    def block_until_complete(
            self,
            namespace: str = None,
            *,
            delay_time: int = 0,
            timeout: int = None,
            ignore_timeout: bool = False,
            cycle: Union[int, float] = .1
    ) -> list:
        """
        Wait for all tasks in the specified namespace to complete.
        @param namespace:      A namespace.
        @param delay_time:     How many seconds to wait before entering the loop check phase.
        @param timeout:        Tasks timeouts.
        @param ignore_timeout: If true, a task timeout will throw an exception.
        @param cycle:          The loop checks the duration of the task.
        @return:               Tasks result.
        """

    def get(self):
        raise NotImplementedError

    def batch_at_and_wait_complete(
            self,
            func: Callable,
            *params,
            **kw
    ) -> list:
        pass

    @staticmethod
    def block(sleep: int):
        """The actual execution will be time.sleep()."""
        pass

    @staticmethod
    def random_namespace() -> str:
        """Return a random uuid4 string."""


class IsddcThreadPool(IsddcProcessPool, ThreadPool):
    def __init__(
            self,
            name: str = None,
            *,
            processes: int = None,
            **kw
    ):
        """
        Create a thread pool.
        @param name:      Pool name.
        @param processes: Thread number.
        """


class _______i________s________d_______d_______c_______:
    __import__(f'{__name__}.i {__name__[6:]}')
    package = sys.modules[__name__]
    main = sys.modules[f'{__name__}.i {__name__[6:]}']

    for ifunc in __all__:
        setattr(package, ifunc, getattr(main, ifunc))


iasync = IsddcAsyncTasks
